#include <windows.h>
#include <stdio.h>
#include <GdiPlus.h>
#include "setscrollbar_img.h"
#include "resource.h"
using namespace 	Gdiplus;
#include "gdip_util.h"
#include "gdip_grid.h"

#pragma comment(lib,"gdiplus.lib")

#define MYWNDCLASS		"RpgVxImgCnvClass"
#define MYWNDTITLE		"RpgVxImgCnv"
#define SAVE_NAME		"MapChipSet"
#define CELL_SIZE		32
#define DPI				96		// 𑜓x

GdiplusStartupInput gdiSI;
ULONG_PTR			gdiToken;
Bitmap				*Bmp_R;
int					wdh,hgt;
bool				g_flag_editable = false;	// ҏW\tOi0:ҏW֎~A1:ҏW\j
int					g_idx_roof = 0;				// ҏW`tOi0:n`PA1:n`QA2:j
char				g_ext[][5] = {"png","bmp"};	// ۑt@C̊gq
char		g_sname[MAX_PATH/2] = SAVE_NAME;	// ۑt@C
Point		g_posSel;							// ݑIĂW
COLORREF	g_CustColors[16];
COLORREF	g_color[] = {0x000000ff, 0x00808080};	// 0:gA1:wiF

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
int		CALLBACK ProcSetDlg(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
int		CALLBACK ProcSaveHook(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);
void	M_LButtonUp(HWND hWnd);
void	M_Paint(HDC hDC, int x, int y, RECT rc_wnd);
void	Read_Image(HWND hWnd, char *fname);
bool	Save_Image(char *filename);
bool	Open_FileDlg(HWND hWnd);
bool	Save_FileDlg(HWND hWnd);
void	Open_ColorDlg(HWND hWnd, int idx_clr);

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;
	
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX);
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(GRAY_BRUSH);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	DWORD	dwStyle = WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE;
	DWORD	dwStyleEx = WS_EX_CLIENTEDGE | WS_EX_ACCEPTFILES;
	RECT	rc = {0, 0, 512+1, 512+1};
	AdjustWindowRectEx(&rc, dwStyle, TRUE, dwStyleEx);
	
	HMENU hMenu = LoadMenu(hInst,MAKEINTRESOURCE(IDR_MENU1));
	
	hWnd = CreateWindowEx(dwStyleEx,
				MYWNDCLASS,
				MYWNDTITLE,
				dwStyle,
				CW_USEDEFAULT, CW_USEDEFAULT, rc.right-rc.left, rc.bottom-rc.top,
				NULL,
				hMenu,
				hInst,
				NULL);

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static int x,y;
	static RECT rc_wnd;
	
	switch (uMsg)
	{
	case WM_CREATE:
		{
			GdiplusStartup(&gdiToken, &gdiSI, NULL);
			Set_ScrollBar(hWnd);
			CheckMenuRadioItem(GetMenu(hWnd), IDM_FORMAT_LAND, IDM_FORMAT_ROOF, IDM_FORMAT_LAND, MF_BYCOMMAND | MFS_CHECKED);
		}
		return 0;
	case WM_SHOWWINDOW:
		if(__argc > 1){
			Read_Image(hWnd, __argv[1]);
			__argc = 0;
		}
		return 0;
	case WM_SIZE:
		Set_Scroll_nPage(hWnd);
		SetRect(&rc_wnd, 0, 0, LOWORD(lParam), HIWORD(lParam));
		break;
	case WM_SETFOCUS:
		g_flag_editable = false;
		return 0;
	case WM_DROPFILES:
		{
			char	fname[MAX_PATH];
			HDROP	hDrop;
			hDrop = (HDROP) wParam;
			DragQueryFile(hDrop, 0, fname, sizeof(fname));
			Read_Image(hWnd, fname);
			DragFinish(hDrop);
		}
		return 0;
	case WM_HSCROLL:
		Move_Scroll_H(hWnd, wParam);
		break;
	case WM_VSCROLL:
		Move_Scroll_V(hWnd, wParam);
		break;
	case WM_MOUSEMOVE:
		x = (scr_x + LOWORD(lParam)) / CELL_SIZE;
		y = (scr_y + HIWORD(lParam)) / CELL_SIZE;
		InvalidateRect(hWnd, NULL, FALSE);
		return 0;
	case WM_LBUTTONUP:
		if(g_flag_editable)
			M_LButtonUp(hWnd);
		else
			g_flag_editable = true;
		return 0;
	case WM_PAINT:
		{
			HDC				hDC;
			PAINTSTRUCT 	ps;
			hDC = BeginPaint(hWnd,&ps);
			M_Paint(hDC, x, y, rc_wnd);
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDM_OPEN:				// J
			g_flag_editable = false;
			Open_FileDlg(hWnd);
			return 0;
		case IDM_EXIT:				// I
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			return 0;
		case IDM_FORMAT_LAND:		// n`P
			g_idx_roof = 0;
			CheckMenuRadioItem(GetMenu(hWnd), IDM_FORMAT_LAND, IDM_FORMAT_ROOF, IDM_FORMAT_LAND, MF_BYCOMMAND | MFS_CHECKED);
			return 0;
		case IDM_FORMAT_LAND2:		// n`Q
			g_idx_roof = 1;
			CheckMenuRadioItem(GetMenu(hWnd), IDM_FORMAT_LAND, IDM_FORMAT_ROOF, IDM_FORMAT_LAND2, MF_BYCOMMAND | MFS_CHECKED);
			return 0;
		case IDM_FORMAT_ROOF:		// 
			g_idx_roof = 2;
			CheckMenuRadioItem(GetMenu(hWnd), IDM_FORMAT_LAND, IDM_FORMAT_ROOF, IDM_FORMAT_ROOF, MF_BYCOMMAND | MFS_CHECKED);
			return 0;
		case IDM_COLOR_FRAME: 		// g̐F
			Open_ColorDlg(hWnd, 0);
			InvalidateRect(hWnd, NULL, FALSE);
			return 0;
		case IDM_COLOR_BACK: 		// wiF
			Open_ColorDlg(hWnd, 1);
			InvalidateRect(hWnd, NULL, FALSE);
			return 0;
		}
		break;
	case WM_CLOSE:
		delete Bmp_R;
		Bmp_R = NULL;
		g_flag_editable = false;
		g_idx_roof = 0;
		DestroyWindow(hWnd);
		GdiplusShutdown(gdiToken);
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// WndProc

// ۑ_CAO tbNvV[W
int CALLBACK ProcSaveHook(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch( uMsg )
	{
	case WM_NOTIFY:
		{
			NMHDR *phdr = (NMHDR *)lParam;
			switch(phdr->code)
			{
			case CDN_TYPECHANGE:	// gqύXꂽƂ
				{
					LPOFNOTIFY	lpon = (LPOFNOTIFY) lParam;
					char		*p,str[MAX_PATH];
					SendDlgItemMessage(GetParent(hDlg), edt1, WM_GETTEXT, sizeof(str), (LPARAM) str);
					if(strlen(str)){
						p = strrchr(str,'.');
						if(p){
							sprintf(p,".%s",g_ext[lpon->lpOFN->nFilterIndex-1]);
						}
						else{
							sprintf(str,"%s.%s",str,g_ext[lpon->lpOFN->nFilterIndex-1]);
						}
						SendDlgItemMessage(GetParent(hDlg), edt1, WM_SETTEXT, 0, (LPARAM) str);
					}
				}
				return TRUE;
			default:
				return FALSE;
			}
		}
		return TRUE;
	case WM_COMMAND:
		switch( wParam )
		{
		case IDCANCEL:
			return TRUE;
		}
		return FALSE;
	default:
		return FALSE;
	}
	return TRUE;
}// ProcSaveHook

void M_LButtonUp(HWND hWnd)
{
	if(Bmp_R){
		Save_FileDlg(hWnd);
	}
}// M_LButtonUp

void M_Paint(HDC hDC, int x, int y, RECT rc_wnd)
{
	Graphics g(hDC);
	if(Bmp_R){
		Bitmap BmpCp(rc_wnd.right, rc_wnd.bottom, PixelFormat24bppRGB);
		Graphics gBmp(&BmpCp);
		Rect rcWnd(0, 0, BmpCp.GetWidth(), BmpCp.GetHeight());
		gBmp.SetClip(rcWnd);
		SolidBrush brush(RefToArgb(g_color[1]));
		gBmp.FillRectangle(&brush, rcWnd);
		gBmp.DrawImage(Bmp_R, - scr_x, - scr_y, wdh, hgt);
		int wdh_min = (rcWnd.Width < wdh+1) ? rcWnd.Width : wdh+1;
		int hgt_min = (rcWnd.Height < hgt+1) ? rcWnd.Height : hgt+1;
		Draw_Grid(&BmpCp, Rect(0, 0, wdh_min,  hgt_min), 100, Point(CELL_SIZE, CELL_SIZE), Point(0, 0));
		int wdh_rc,hgt_rc;
		switch (g_idx_roof)
		{
		case 0:	// n`P
			wdh_rc = 64;
			hgt_rc = 96;
			break;
		case 1:	// n`Q
			wdh_rc = 96;
			hgt_rc = 128;
			break;
		case 2:	// 
			wdh_rc = 64;
			hgt_rc = 64;
			break;
		}
		Rect rcFrm(- scr_x + x * 32, - scr_y + y * 32, wdh_rc, hgt_rc);
		if(rcFrm.X + rcFrm.Width > wdh){
			rcFrm.X = wdh - rcFrm.Width;
		}
		if(rcFrm.Y + rcFrm.Height > hgt){
			rcFrm.Y = hgt - rcFrm.Height;
		}
		g_posSel.X = rcFrm.X;
		g_posSel.Y = rcFrm.Y;
		gBmp.FillRectangle(&SolidBrush(Color(RefToArgb(g_color[0], 128))), rcFrm);
		gBmp.DrawRectangle(&Pen(Color(RefToArgb(g_color[0])), 2), rcFrm);
		g.DrawImage(&BmpCp, 0, 0, BmpCp.GetWidth(), BmpCp.GetHeight());
		gBmp.ResetClip();
	}
}// M_Paint

// t@C摜ǂݍ
void Read_Image(HWND hWnd, char *fname)
{
	WCHAR	wfname[MAX_PATH];
	
	MultiByteToWideChar(CP_ACP,0,fname,-1,wfname,sizeof(wfname));
	delete Bmp_R;
	Bmp_R = Bitmap::FromFile(wfname,FALSE);
	wdh = Bmp_R->GetWidth();
	hgt = Bmp_R->GetHeight();
	Set_Scroll_nMax(hWnd, wdh, hgt);
	InvalidateRect(hWnd, NULL, TRUE);
}// Read_Image

// 摜t@C̕ۑ
bool Save_Image(char *filename)
{
	if(!Bmp_R){
		return false;
	}
	
	Status	st = GenericError;
	char	*p = strrchr(filename, '.');
	if(p){
		POINT ptDst1[][4] = {{{0,0},{1,0},{0,1},{1,1}},{{2,0},{3,0},{2,1},{3,1}},
							{{4,0},{5,0},{4,1},{5,1}},{{6,0},{7,0},{6,1},{7,1}},
							{{0,2},{1,2},{0,3},{1,3}},{{2,2},{3,2},{2,3},{3,3}},
							{{4,2},{5,2},{4,3},{5,3}},{{6,2},{7,2},{6,3},{7,3}},
							{{0,4},{1,4},{0,5},{1,5}},{{2,4},{3,4},{2,5},{3,5}},
							{{4,4},{5,4},{4,5},{5,5}},{{6,4},{7,4},{6,5},{7,5}},
							{{0,6},{1,6},{0,7},{1,7}},{{2,6},{3,6},{2,7},{3,7}},
							{{4,6},{5,6},{4,7},{5,7}},{{6,6},{7,6},{6,7},{7,7}},
							{{0,8},{1,8},{0,9},{1,9}},{{2,8},{3,8},{2,9},{3,9}},
							{{4,8},{5,8},{4,9},{5,9}},{{6,8},{7,8},{6,9},{7,9}},
							{{0,10},{1,10},{0,11},{1,11}},{{2,10},{3,10},{2,11},{3,11}},
							{{4,10},{5,10},{4,11},{5,11}},{{6,10},{7,10},{6,11},{7,11}},
							{{0,12},{1,12},{0,13},{1,13}},{{2,12},{3,12},{2,13},{3,13}},
							{{4,12},{5,12},{4,13},{5,13}},{{6,12},{7,12},{6,13},{7,13}},
							{{0,14},{1,14},{0,15},{1,15}},{{2,14},{3,14},{2,15},{3,15}},
							{{4,14},{5,14},{4,15},{5,15}},{{6,14},{7,14},{6,15},{7,15}},
							{{0,16},{1,16},{0,17},{1,17}},{{2,16},{3,16},{2,17},{3,17}},
							{{4,16},{5,16},{4,17},{5,17}},{{6,16},{7,16},{6,17},{7,17}},
							{{0,18},{1,18},{0,19},{1,19}},{{2,18},{3,18},{2,19},{3,19}},
							{{4,18},{5,18},{4,19},{5,19}},{{6,18},{7,18},{6,19},{7,19}}};
		POINT ptSrc1[][4] = {{{0,2},{1,2},{0,3},{1,3}},{{2,2},{3,2},{2,3},{3,3}},
							{{2,2},{1,2},{2,3},{1,3}},{{0,3},{1,3},{0,4},{1,4}},
							{{0,4},{1,4},{0,5},{1,5}},{{2,4},{3,4},{2,5},{3,5}},
							{{2,4},{1,4},{2,5},{1,5}},{{2,3},{3,3},{2,4},{3,4}},
							{{0,2},{3,2},{0,3},{3,3}},{{0,2},{1,2},{0,5},{1,5}},
							{{2,2},{3,2},{2,5},{3,5}},{{1,2},{2,2},{1,5},{2,5}},
							{{0,3},{3,3},{0,4},{3,4}},{{0,4},{3,4},{0,5},{3,5}},
							{{2,4},{1,4},{2,3},{1,3}},{{0,2},{3,2},{0,5},{3,5}},
							{{2,0},{1,4},{2,3},{1,3}},{{2,4},{3,0},{2,3},{1,3}},
							{{2,4},{1,4},{2,3},{3,1}},{{2,4},{1,4},{2,1},{1,3}},
							{{2,0},{1,4},{2,1},{1,3}},{{2,0},{3,0},{2,3},{1,3}},
							{{2,4},{3,0},{2,3},{3,1}},{{2,4},{1,4},{2,1},{3,1}},
							{{0,2},{1,2},{0,4},{3,1}},{{0,3},{3,0},{0,5},{1,5}},
							{{2,2},{3,2},{2,1},{3,4}},{{2,0},{3,3},{2,5},{3,5}},
							{{2,0},{3,3},{2,1},{3,4}},{{2,0},{3,0},{1,5},{2,5}},
							{{0,3},{3,0},{0,4},{3,1}},{{1,2},{2,2},{2,1},{3,1}},
							{{2,4},{3,3},{2,1},{3,4}},{{2,4},{3,0},{1,5},{2,5}},
							{{0,3},{1,4},{0,4},{3,1}},{{1,2},{2,2},{2,3},{3,1}},
							{{2,0},{3,3},{2,3},{3,4}},{{2,0},{1,4},{1,5},{2,5}},
							{{0,3},{3,0},{0,4},{1,3}},{{1,2},{2,2},{2,1},{1,3}}};
		
		POINT ptDst2[][4] = {{{0,0},{1,0},{0,1},{1,1}},{{2,0},{3,0},{2,1},{3,1}},
							{{4,0},{5,0},{4,1},{5,1}},{{6,0},{7,0},{6,1},{7,1}},
							{{0,2},{1,2},{0,3},{1,3}},{{2,2},{3,2},{2,3},{3,3}},
							{{4,2},{5,2},{4,3},{5,3}},{{6,2},{7,2},{6,3},{7,3}},
							{{0,4},{1,4},{0,5},{1,5}},{{2,4},{3,4},{2,5},{3,5}},
							{{4,4},{5,4},{4,5},{5,5}},{{6,4},{7,4},{6,5},{7,5}},
							{{0,6},{1,6},{0,7},{1,7}},{{2,6},{3,6},{2,7},{3,7}},
							{{4,6},{5,6},{4,7},{5,7}},{{6,6},{7,6},{6,7},{7,7}},
							{{0,8},{1,8},{0,9},{1,9}},{{2,8},{3,8},{2,9},{3,9}},
							{{4,8},{5,8},{4,9},{5,9}},{{6,8},{7,8},{6,9},{7,9}},
							{{0,10},{1,10},{0,11},{1,11}},{{2,10},{3,10},{2,11},{3,11}},
							{{4,10},{5,10},{4,11},{5,11}},{{6,10},{7,10},{6,11},{7,11}},
							{{0,12},{1,12},{0,13},{1,13}},{{2,12},{3,12},{2,13},{3,13}},
							{{4,12},{5,12},{4,13},{5,13}},{{6,12},{7,12},{6,13},{7,13}},
							{{0,14},{1,14},{0,15},{1,15}},{{2,14},{3,14},{2,15},{3,15}},
							{{4,14},{5,14},{4,15},{5,15}},{{6,14},{7,14},{6,15},{7,15}},
							{{0,16},{1,16},{0,17},{1,17}},{{2,16},{3,16},{2,17},{3,17}},
							{{4,16},{5,16},{4,17},{5,17}},{{6,16},{7,16},{6,17},{7,17}},
							{{0,18},{1,18},{0,19},{1,19}},{{2,18},{3,18},{2,19},{3,19}},
							{{4,18},{5,18},{4,19},{5,19}},{{6,18},{7,18},{6,19},{7,19}},
							{{0,20},{1,20},{0,21},{1,21}},{{2,20},{3,20},{2,21},{3,21}},
							{{4,20},{5,20},{4,21},{5,21}},{{6,20},{7,20},{6,21},{7,21}},
							{{0,22},{1,22},{0,23},{1,23}},{{2,22},{3,22},{2,23},{3,23}},
							{{4,22},{5,22},{4,23},{5,23}},{{6,22},{7,22},{6,23},{7,23}}};
		POINT ptSrc2[][4] = {{{0,2},{1,2},{0,3},{1,3}},{{2,2},{3,2},{2,3},{3,3}},
							{{4,2},{5,2},{4,3},{5,3}},{{0,0},{1,0},{0,1},{1,1}},
							{{0,4},{1,4},{0,5},{1,5}},{{2,4},{3,4},{2,5},{3,5}},
							{{4,4},{5,4},{4,5},{5,5}},{{4,0},{5,0},{4,1},{5,1}},
							{{0,6},{1,6},{0,7},{1,7}},{{2,6},{3,6},{2,7},{3,7}},
							{{4,6},{5,6},{4,7},{5,7}},{{2,0},{3,0},{2,1},{3,1}},
							{{0,0},{3,2},{0,1},{3,7}},{{2,2},{3,2},{2,7},{3,7}},
							{{2,2},{1,0},{2,7},{1,1}},{{2,0},{3,0},{2,1},{3,1}},
							{{0,0},{1,0},{0,5},{5,5}},{{0,4},{5,4},{0,5},{5,5}},
							{{0,4},{5,4},{0,1},{1,1}},{{2,0},{3,0},{2,1},{3,1}},
							{{0,2},{1,2},{0,3},{5,1}},{{4,2},{5,2},{4,1},{5,3}},
							{{4,0},{5,6},{4,7},{5,7}},{{0,6},{5,0},{0,7},{1,7}},
							{{2,2},{3,2},{4,1},{5,1}},{{4,0},{5,4},{4,1},{5,5}},
							{{4,0},{5,0},{2,7},{3,7}},{{0,4},{5,0},{0,5},{5,1}},
							{{2,2},{3,2},{4,1},{3,5}},{{4,0},{5,4},{2,5},{5,5}},
							{{4,0},{3,4},{2,7},{3,7}},{{0,4},{5,0},{0,5},{3,5}},
							{{2,2},{3,2},{2,5},{5,1}},{{2,4},{5,4},{4,1},{5,5}},
							{{2,4},{5,0},{2,7},{3,7}},{{0,4},{3,4},{0,5},{5,1}},
							{{2,4},{3,4},{2,5},{5,1}},{{2,4},{3,4},{4,1},{3,5}},
							{{4,0},{3,4},{2,5},{3,5}},{{2,4},{5,0},{2,5},{3,5}},
							{{2,4},{3,4},{4,1},{5,1}},{{4,0},{3,4},{4,1},{3,5}},
							{{4,0},{5,0},{2,5},{3,5}},{{2,4},{5,0},{2,5},{5,1}},
							{{2,4},{5,0},{2,5},{5,1}},{{4,0},{3,4},{4,1},{5,1}},
							{{4,0},{5,0},{4,1},{3,5}},{{2,4},{5,0},{4,1},{5,1}}};
		
		POINT ptDst3[][4] = {{{0,0},{1,0},{0,1},{1,1}},{{2,0},{3,0},{2,1},{3,1}},
							{{4,0},{5,0},{4,1},{5,1}},{{0,2},{1,2},{0,3},{1,3}},
							{{2,2},{3,2},{2,3},{3,3}},{{4,2},{5,2},{4,3},{5,3}},
							{{0,4},{1,4},{0,5},{1,5}},{{2,4},{3,4},{2,5},{3,5}},
							{{4,4},{5,4},{4,5},{5,5}},{{0,6},{1,6},{0,7},{1,7}},
							{{2,6},{3,6},{2,7},{3,7}},{{4,6},{5,6},{4,7},{5,7}}};
		POINT ptSrc3[][4] = {{{0,0},{1,0},{0,1},{1,1}},{{1,0},{2,0},{1,1},{2,1}},
							{{2,0},{3,0},{2,1},{3,1}},{{0,1},{1,1},{0,2},{1,2}},
							{{1,1},{2,1},{1,2},{2,2}},{{2,1},{3,1},{2,2},{3,2}},
							{{0,2},{1,2},{0,3},{1,3}},{{1,2},{2,2},{1,3},{2,3}},
							{{2,2},{3,2},{2,3},{3,3}},{{0,0},{1,0},{0,3},{1,3}},
							{{1,0},{2,0},{1,3},{2,3}},{{2,0},{3,0},{2,3},{3,3}}};
		int		i,j,bmpW_wdh,bmpW_hgt,chip_num;
		WCHAR	wsname[MAX_PATH];
		CLSID	Clsid = Get_Mime_Type(p+1);
		MultiByteToWideChar(CP_ACP,0,filename,-1,wsname,sizeof(wsname));
		switch (g_idx_roof)
		{
		case 0:	// n`P
			bmpW_wdh = 128;
			bmpW_hgt = 320;
			break;
		case 1:	// n`Q
			bmpW_wdh = 128;
			bmpW_hgt = 384;
			break;
		case 2:	// 
			bmpW_wdh = 96;
			bmpW_hgt = 128;
			break;
		}
		Bitmap Bmp_W(bmpW_wdh, bmpW_hgt, PixelFormat32bppARGB);
		Bmp_W.SetResolution((REAL) DPI, (REAL) DPI);
		Bmp_R->SetResolution((REAL) DPI, (REAL) DPI);
		Graphics gBmp(&Bmp_W);
		chip_num = (bmpW_wdh / CELL_SIZE) * (bmpW_hgt /CELL_SIZE);
		switch (g_idx_roof)
		{
		case 0:	// n`P
			for(i=0;i<chip_num;i++){
				for(j=0;j<4;j++){
					gBmp.DrawImage(Bmp_R, ptDst1[i][j].x * 16, ptDst1[i][j].y * 16, 
									g_posSel.X + ptSrc1[i][j].x * 16, g_posSel.Y + ptSrc1[i][j].y * 16, 
									16, 16, UnitPixel);
				}
			}
			break;
		case 1:	// n`Q
			for(i=0;i<chip_num;i++){
				for(j=0;j<4;j++){
					gBmp.DrawImage(Bmp_R, ptDst2[i][j].x * 16, ptDst2[i][j].y * 16, 
									g_posSel.X + ptSrc2[i][j].x * 16, g_posSel.Y + ptSrc2[i][j].y * 16, 
									16, 16, UnitPixel);
				}
			}
			break;
		case 2:	// 
			for(i=0;i<chip_num;i++){
				for(j=0;j<4;j++){
					gBmp.DrawImage(Bmp_R, ptDst3[i][j].x * 16, ptDst3[i][j].y * 16, 
									g_posSel.X + ptSrc3[i][j].x * 16, g_posSel.Y + ptSrc3[i][j].y * 16, 
									16, 16, UnitPixel);
				}
			}
			break;
		}
		st = Bmp_W.Save(wsname, &Clsid, NULL);
	}
	if(st == Ok)
		return true;
	return false;
}// Save_Image

// I[vt@C_CAO
bool Open_FileDlg(HWND hWnd)
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH] = "";
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.Flags = OFN_HIDEREADONLY; 
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	ofn.lpstrFilter =	"摜t@C (*.bmp; gif; png; tif)\0" "*.bmp;*.dib;*.rle;*.gif;*.png;*.tif\0" 
						"rbg}bv (*.bmp; dib; rle)\0" "*.bmp;*.dib;*.rle\0" 
						"GIF (*.gif)\0" "*.gif\0" 
						"PNG (*.png)\0" "*.png\0" 
						"TIFF (*.tif; tiff)\0" "*.tif;*.tiff\0" 
						"ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	if(GetOpenFileName(&ofn)){
		Read_Image(hWnd, fn);
	}
	return TRUE;
}// Open_FileDlg

// ۑt@C_CAO
bool Save_FileDlg(HWND hWnd)
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH] = "";
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize  = sizeof(OPENFILENAME);
	ofn.hwndOwner	 = hWnd;
	ofn.Flags		 = OFN_ENABLEHOOK | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_EXPLORER;
	ofn.lpstrFile	 = fn;
	ofn.nMaxFile	 = sizeof(fn);
	ofn.lpstrFilter =	"PNG (*.png)\0" "*.png\0" 
						"rbg}bv (*.bmp)\0" "*.bmp\0" 
						"ׂẴt@C (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	ofn.lpfnHook = (LPOFNHOOKPROC) ProcSaveHook;
	
	if (GetSaveFileName(&ofn))
	{
		bool flag = 0;
		char sfname[MAX_PATH];
		
		strcpy(sfname, fn);
		
		char *p = strrchr(sfname, '.');
		if(!p)	sprintf(sfname, "%s.%s", sfname, g_ext[ofn.nFilterIndex - 1]);
		
		flag = Save_Image(sfname);
		
		return flag;
	}
	return 0;
}// Save_FileDlg

// J[_CAO
void Open_ColorDlg(HWND hWnd, int idx_clr)
{
	CHOOSECOLOR cc;
	ZeroMemory(&cc, sizeof(cc));
	cc.lStructSize = sizeof(CHOOSECOLOR);
	cc.hwndOwner = hWnd;
	cc.rgbResult = g_color[idx_clr];
	cc.lpCustColors = g_CustColors;
	cc.Flags = CC_RGBINIT;
	if(ChooseColor(&cc)){
		g_color[idx_clr] = cc.rgbResult;
	}
}// Open_ColorDlg
